

#include <Wire.h>
#include "Adafruit_LEDBackpack.h"
#include "Adafruit_GFX.h"

Adafruit_8x8matrix matrix1 = Adafruit_8x8matrix();
Adafruit_8x8matrix matrix2 = Adafruit_8x8matrix();

void setup() {

  Serial.begin(9600);

  int tensDigit;
  int onesDigit;
  int d20result;
  int switchStatus;

  randomSeed(analogRead(0));

  matrix1.begin(0x70); //no jumper soldered
  matrix2.begin(0x72); //with A1 soldered
  matrix1.clear();
  matrix2.clear();

  int reedlow = 5;
  int reedhigh = 6;
  int buzzer = 9;
  int switch1 = 10;
  int switch2 = 11;

  pinMode(reedlow, INPUT_PULLUP); //Use a pull up resistor so that the value doesn't randomly float to "zero". -Steven
  pinMode(reedhigh, INPUT_PULLUP);
  pinMode(buzzer, OUTPUT);
  pinMode(switch1, INPUT); //Pull up not required here because you're using pull-down resistors on the breadboard, which serve a similiar purpose. -Steven
  pinMode(switch2, INPUT);

  matrix1.clear();
  matrix2.clear();

  Serial.println(digitalRead(switch1));
  Serial.println(digitalRead(switch2));


  // switch selection to roll d100

  if (digitalRead(switch1) == HIGH) {

    int tensDigit = random(0, 10); //Need to set the upper bound to your highest value + 1, so 10 in this case. -Steven
    int onesDigit = random(0, 10);

    Serial.print(tensDigit);
    Serial.println(onesDigit);
    Serial.println();


    int cheatlow = digitalRead(reedlow); //You need to save the value after reading it -Steven
    int cheathigh = digitalRead(reedhigh); //You could also read it the same way as you do switch1 above, personal preference. -Steven

    if (cheatlow == LOW) {
      tensDigit = 0;
      onesDigit = 0;
    }

    if (cheathigh == LOW) {
      tensDigit = 9;
      onesDigit = 9;
    }


    //write result
    matrix1.setTextSize(1);
    matrix1.setTextWrap(true);
    matrix1.setTextColor(LED_ON);
    matrix1.print(tensDigit);
    matrix1.writeDisplay();

    matrix2.setTextSize(1);
    matrix2.setTextWrap(true);
    matrix2.setTextColor(LED_ON);
    matrix2.print(onesDigit);
    matrix2.writeDisplay();

    tone(9, 100, 500); 
    //noTone(9); //By doing it this way you end the tone early, making it too short imo.
    //By adding a duration, such as the 500 ms one above, theres no need to explictly end the tone anyway. -Steven

  }

  // switch selection roll d20

  if (digitalRead(switch2) == HIGH) {
    int d20result = random(0, 20);

    Serial.print("d20 result: ");
    Serial.println(d20result + 1);
    Serial.println();

	int cheatlow = digitalRead(reedlow); //This section didn't read the cheat switches at all. So I added them -Steven
    int cheathigh = digitalRead(reedhigh);


    if (cheatlow == LOW) {
      d20result = 0;
    }

    if (cheathigh == LOW) {
      d20result = 19;
    }

	//This code works, but let me suggest something cleaner -Steven
	/*
    if (d20result == 19) {
      tensDigit = 2;
      onesDigit = 0;
    }

    else if (d20result > 9) {
      tensDigit = 1;
      onesDigit = d20result - 9;
    }

    else if (d20result == 9) {
      tensDigit = 1;
      onesDigit = 0;
    }

    else if (d20result < 9) {
      tensDigit = 0;
      onesDigit = d20result + 1;
    }
	*/
	d20result += 1; //Add 1 since we randomly generated from 0-19. This isn't required if the random number is 1-20
	tensDigit = d20result / 10;
	onesDigit = d20result % 10;



    Serial.print("d20 result: ");
    Serial.println(d20result);
    Serial.println(tensDigit);
    Serial.println(onesDigit);
    Serial.println();

  }



  //write result
  matrix1.setTextSize(1);
  matrix1.setTextWrap(true);
  matrix1.setTextColor(LED_ON);
  matrix1.print(tensDigit);
  matrix1.writeDisplay();

  matrix2.setTextSize(1);
  matrix2.setTextWrap(true);
  matrix2.setTextColor(LED_ON);
  matrix2.print(onesDigit);
  matrix2.writeDisplay();

  tone(9, 100, 500);
  //noTone(9);
}


void loop() {
}



